/**
 *
 * SIROCCO
 * Copyright (C) 2011 France Telecom
 * Contact: sirocco@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *  $Id$
 *
 */

package org.ow2.sirocco.vmm.agent.domain;

import javax.management.ObjectName;

import org.apache.log4j.Logger;
import org.ow2.sirocco.vmm.agent.main.AgentCommon;
import org.ow2.sirocco.vmm.agent.main.VirtManagerAgent;
import org.ow2.sirocco.vmm.api.StoragePoolMXBean;

public abstract class AbstractStoragePool extends ManagedResource implements StoragePoolMXBean {
    static protected Logger logger = Logger.getLogger(AbstractStoragePool.class);

    protected AbstractStoragePool(final ObjectName objectName) {
        super(objectName);
    }

    public void release() {
    }

    public void delete() {
        try {
            AgentCommon.getMBeanServer().unregisterMBean(this.getObjectName());
            VirtManagerAgent.getInstance().setResourceTreeDirty();
        } catch (Exception ex) {
            AbstractStoragePool.logger.error(ex);
        }
        this.release();
    }

}
