/**
 *
 * SIROCCO
 * Copyright (C) 2011 France Telecom
 * Contact: sirocco@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *  $Id: MonitoringDriver.java 132 2011-07-11 08:54:11Z chou $
 *
 */

package org.ow2.sirocco.vmm.agent.monitoring.driver;

import org.ow2.sirocco.vmm.agent.monitoring.api.MonitoringDriverAPI;
import org.ow2.sirocco.vmm.api.VMMException;

/**
 * The Driver class is the entry point of a driver encapsulating a specific
 * monitoring service and its associated management protocol. A driver boils
 * down to a factory of monitoring service.
 */
public interface MonitoringDriver {
    /**
     * Builds a new Monitoring Service
     * 
     * @param name user-friendly name of the monitoring service
     * @param objectname JMX object name of the monitoring service
     * @param props driver-specific properties to be used to create this
     *        monitoring service
     * @return
     */
    MonitoringDriverAPI newMonitoringService(String name) throws IllegalArgumentException, VMMException;

    /**
     * give the attributes of the monitoring service
     * 
     * @return
     */
    String[] getMonitoringServiceCreationAttributes();

}
